//TODO if A or IMG tag are selected - select their direct parents


document.addEventListener('DOMContentLoaded', function () {
    chrome.tabs.getCurrent(function (tab) {
        try {
            if (tab.url.includes('chrome://')) {
                return;
            }
        } catch (e) {
            return null
        }
    });

    document.getElementById('loginBtn').addEventListener('click', function () {
        var xhr = new XMLHttpRequest();   // new HttpRequest instance 
        // xhr.open("POST", 'http://localhost:8080/auth/login');
        xhr.open("POST", 'https://app.gibb.ai/auth/login');
        // xhr.open("POST", 'https://dev.gibb.ai/auth/login');
        xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        xhr.send(JSON.stringify({ "email": document.querySelector('input[name="username"]').value, "password": document.querySelector('input[name="password"]').value }));
        xhr.onreadystatechange = function () {
            if (xhr.readyState == XMLHttpRequest.DONE && xhr.status == 200) {
                let token = JSON.parse(xhr.responseText).token

                console.log(token)
                chrome.storage.sync.set({ "inspectorToken": token }, function () {
                    initChecker();
                    // window.reload();
                });
            } else if (xhr.readyState == XMLHttpRequest.DONE && xhr.status == 500) {
                alert('Invalid Credentials')
            }
        }
    })
    initChecker();
    function initChecker() {
        function modifyDOM() {

            // chrome.tabs.getCurrent(function (tab) {
            //     console.log(tab.url);
            // });
            // chrome.storage.sync.remove("inspectorToken", function () {

            // });
            // return;

            chrome.storage.sync.get("inspectorToken", function (item) {
                console.log(item)
                if (item.inspectorToken == null) {
                    return;
                }
                document.querySelectorAll('*').forEach(function (elem) {
                    var new_element = elem.cloneNode(true);
                    elem.parentNode.replaceChild(new_element, elem);
                })

                //         let docscript = document.createElement('script');
                //         docscript.innerText = `
                //         window.onbeforeunload = function(){
                //     return 'Are you sure you want to leave?';
                // };`;
                //         document.body.append(docscript)

                let keyUpListener = function (e) {
                    if (e.key == "Escape") {
                        quitSelector();
                    }
                }
                if (document.getElementById('previous_fullpage_nav') != null)
                    document.getElementById('previous_fullpage_nav').remove();
                document.addEventListener('keyup', keyUpListener)
                let existOverlay = document.querySelector('.overlayChecker')
                if (existOverlay != null) {
                    existOverlay.remove()
                }
                let existHoverHighlight = document.querySelectorAll('.hover-backlight');
                if (existHoverHighlight.length) {
                    existHoverHighlight.forEach(e => e.remove());
                }
                let mouseoverHandler = function (event) {
                    if (!document.casinoSelector) {
                        return
                    }
                    // event.target.style.pointerEvents = 'none';
                    if (event.target.tagName == 'DIV' || event.target.tagName == 'LI' || event.target.tagName == 'TR') {
                        highlightElement(event.target)
                        document.hoverHighlight.style.width = event.target.offsetWidth + 'px';
                        document.hoverHighlight.style.height = event.target.offsetHeight + 'px';
                        if (document.documentElement.getAttribute('dir') == 'rtl' || document.body.classList.contains('rtl') || document.documentElement.classList.contains('direction-rtl')) { }
                        document.hoverHighlight.style.top = event.target.getBoundingClientRect().top + window.scrollY + 'px';
                        document.hoverHighlight.style.left = event.target.getBoundingClientRect().left + window.scrollX + 'px';

                        if (event.target.tagName == 'TD') {
                            highlightElement(event.target.parentElement)
                            document.hoverHighlight.style.width = event.target.parentElement.offsetWidth + 'px';
                            document.hoverHighlight.style.height = event.target.parentElement.offsetHeight + 'px';
                            if (document.documentElement.getAttribute('dir') == 'rtl' || document.body.classList.contains('rtl') || document.documentElement.classList.contains('direction-rtl')) { }
                            document.hoverHighlight.style.top = event.target.getBoundingClientRect().top + window.scrollY + 'px';
                            document.hoverHighlight.style.left = event.target.getBoundingClientRect().left + window.scrollX + 'px';

                        } else {
                            // event.target.classList.add('hovered')
                        }
                        return
                    } else {
                        document.hoverHighlight.style.width = '0';
                        document.hoverHighlight.style.height = '0';
                        document.hoverHighlight.style.top = '0';
                        document.hoverHighlight.style.left = '0';
                    }
                    if (event.target.tagName != 'DIV' && event.target.tagName != 'LI' && event.target.tagName != 'TR' && event.target.tagName != 'IMG') {
                        if (event.target.parentElement && event.target.parentElement.tagName == 'TR') {
                            // event.target.parentElement.classList.add('hovered')
                            highlightElement(event.target.parentElement)
                            return;
                        }
                        if (event.target.parentElement && event.target.parentElement.tagName == 'DIV') {
                            // event.target.parentElement.classList.add('hovered')
                            highlightElement(event.target.parentElement)
                            return;
                        }
                        if (event.target.parentElement && event.target.parentElement.parentElement.tagName == 'TR') {
                            // event.target.parentElement.classList.add('hovered')
                            highlightElement(event.target.parentElement.parentElement)
                            return;
                        }
                        if (event.target.parentElement && event.target.parentElement.parentElement && event.target.parentElement.parentElement.parentElement.tagName == 'TR') {
                            // event.target.parentElement.classList.add('hovered')
                            highlightElement(event.target.parentElement.parentElement.parentElement)
                            return;
                        }
                        // if (event.target.parentElement.parentElement.tagName == 'TR') {
                        //     // event.target.parentElement.parentElement.classList.add('hovered')
                        //     highlightElement(event.target.parentElement.parentElement)
                        //     return;
                        // }
                        // if (event.target.parentElement.parentElement.parentElement.tagName == 'TR') {
                        //     // event.target.parentElement.parentElement.parentElement.classList.add('hovered')
                        //     highlightElement(event.target.parentElement.parentElement.parentElement)
                        //     return;
                        // }
                        // mouseoutHandler(event)
                    } else {
                        document.hoverHighlight.style.width = '0';
                        document.hoverHighlight.style.height = '0';
                        document.hoverHighlight.style.top = '0';
                        document.hoverHighlight.style.left = '0';
                        event.target.classList.remove('hovered')
                    }
                    if (event.target.parentNode)
                        event.target.parentNode.replaceChild(event.target.cloneNode(true), event.target)
                }

                let mouseoutHandler = function (event) {
                    if (!document.casinoSelector) {
                        return
                    }
                    document.hoverHighlight.style.width = '0';
                    document.hoverHighlight.style.height = '0';
                    document.hoverHighlight.style.top = '0';
                    document.hoverHighlight.style.left = '0';
                    event.target.classList.remove('hovered')
                }

                if (document.casinoSelector) {
                    console.log('hey')
                    quitSelector(true);
                    return
                    // quitPrevSelector();
                }
                document.casinoSelector = {
                    selectHistory: []
                };

                document.querySelectorAll('div,li,tr,a,img').forEach(el => {
                    el.addEventListener('mouseover', mouseoverHandler)
                    el.addEventListener('mouseout', mouseoutHandler)
                    // el.addEventListener('click', function (e) {
                    //     if (document.casinoSelector != null) {
                    //         console.log('hey!')
                    //         e.preventDefault()
                    //     }
                    // })
                })

                let infoPar = document.createElement('p');
                infoPar.innerHTML = 'Make sure your <b>UK VPN</b> is on <br> Point your ad region and click accept to submit the tracker<br><small style="font-size:14px">Press ESC to cancel</small>';
                infoPar.style.textAlign = 'center'
                infoPar.style.fontSize = '24px'
                infoPar.style.position = 'fixed';
                infoPar.style.width = '100%';
                infoPar.style.top = '50%'
                infoPar.style.left = '50%'
                infoPar.style.transform = 'translate(-50%,-50%)'
                infoPar.style.padding = '5px 10px';
                infoPar.style.zIndex = '10000000010';
                // infoPar.style.lineHeight = '2.5rem';
                infoPar.classList.add('gibb')
                infoPar.style.pointerEvents = 'none';
                infoPar.style.setProperty('text-shadow', '-1px -1px 0 black, 1px -1px 0 black, -1px 1px 0 black, 1px 2px 0 black', 'important')
                // infoPar.style.textShadow = '-2px -2px 0 black, 2px -2px 0 black, -2px 2px 0 black, 2px 2px 0 black;'
                infoPar.style.color = 'white';
                infoPar.style.setProperty('font-family', 'sans-serif', 'important');
                infoPar.style.setProperty('line-height', '1.2', 'important');

                infoPar.style.backgroundColor = 'transparent';
                document.body.append(infoPar)
                document.infoPar = infoPar;

                let quitBtn = document.createElement('button')
                quitBtn.innerText = "QUIT";
                quitBtn.style.position = 'fixed';
                quitBtn.style.padding = '5px 15px';
                quitBtn.style.bottom = '40px';
                quitBtn.style.right = `15px`;
                quitBtn.style.fontSize = `20px`;
                quitBtn.style.zIndex = '1000000001';
                quitBtn.style.borderRadius = '3px';
                quitBtn.style.border = '1px solid white';
                quitBtn.style.color = 'white';
                quitBtn.style.fontWeight = '400';
                quitBtn.style.outline = 'unset';
                quitBtn.style.boxShadow = 'unset';
                quitBtn.style.top = 'unset';
                quitBtn.classList.add('gibb')
                quitBtn.style.setProperty('background', 'transparent', 'important')
                quitBtn.style.setProperty('font-family', 'sans-serif', 'important')
                quitBtn.onclick = quitSelector
                document.body.append(quitBtn)
                document.quitBtn = quitBtn;
                // 


                let logoutBtn = document.createElement('button')
                logoutBtn.innerText = "Logout";
                logoutBtn.style.position = 'fixed';
                logoutBtn.style.padding = '5px 15px';
                logoutBtn.style.bottom = '15px';
                logoutBtn.style.right = ` 25px`;
                logoutBtn.style.fontSize = `10px`;
                logoutBtn.style.fontWeight = '400';
                logoutBtn.style.zIndex = '1000000001';
                // logoutBtn.style.backgroundColor = 'transparent !important';
                logoutBtn.style.borderRadius = '3px';
                // logoutBtn.style.border = '1px solid white';
                logoutBtn.style.color = 'white';
                logoutBtn.style.outline = 'unset';
                logoutBtn.style.boxShadow = 'unset';
                logoutBtn.style.top = 'unset';
                logoutBtn.style.border = 'none';
                logoutBtn.classList.add('gibb')
                logoutBtn.style.setProperty('background', 'transparent', 'important')
                logoutBtn.style.setProperty('font-family', 'sans-serif', 'important')
                logoutBtn.onmouseover = mouseoutHandler
                logoutBtn.onclick = logout
                document.body.append(logoutBtn)
                document.logoutBtn = logoutBtn;

                function logout() {
                    chrome.storage.sync.remove("inspectorToken", function () {
                        quitSelector();
                    });
                }

                function quitSelector(forceQuit = false) {
                    // 
                    if (document.casinoSelector.selectedElement != null && !forceQuit) {
                        return reselect()
                    }
                    // document.body.style.overflow = '';
                    try {
                        document.removeEventListener('keyup', keyUpListener)
                    } catch (e) { }
                    if (document.textarea != null) {
                        unselectElement()
                    }
                    if (document.highlight1 != null && document.highlight2 != null && document.highlight3 != null && document.highlight4 != null) {
                        document.highlight1.remove();
                        document.highlight1 = null;
                        document.highlight2.remove();
                        document.highlight2 = null;
                        document.highlight3.remove();
                        document.highlight3 = null;
                        document.highlight4.remove();
                        document.highlight4 = null;
                    }
                    if (document.style != null) {
                        document.style.remove()
                    }


                    document.infoPar.remove();
                    document.quitBtn.remove();
                    document.logoutBtn.remove();
                    document.overlay.remove();
                    document.hoverHighlight.remove()
                    if (document.casinoSelector.selectedElement)
                        document.casinoSelector.selectedElement.style.pointerEvents = 'unset';
                    // hoverStyle.remove();
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    document.body.querySelectorAll('div,li,tr,a,img').forEach(element => {
                        element.removeEventListener('click', clickListener)
                        element.classList.remove('selectedDiv')
                        element.classList.remove('hovered')

                    })
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => {
                        el.removeEventListener('mouseover', mouseoverHandler)
                        el.removeEventListener('mouseout', mouseoutHandler)
                    })
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => {
                        if (el.tagName == 'A') {
                            let clone = el.cloneNode(true)
                            el.parentNode.replaceChild(clone, el)
                        }
                    })
                    document.body.querySelectorAll('a').forEach(element => {
                        element.onclick = function () {
                            console.log('click')
                            window.open(element.href, "_blank")
                        }
                    })
                    document.casinoSelector = null
                }
                function quitPrevSelector() {
                    // document.body.style.overflow = '';
                    document.removeEventListener('keyup', keyUpListener)
                    // document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    document.body.querySelectorAll('div,li,tr,a,img').forEach(element => {
                        element.removeEventListener('click', clickListener)
                        // element.removeEventListener('click', clickListener)
                        element.classList.remove('selectedDiv')
                        element.classList.remove('hovered')
                    })
                    document.casinoSelector = null
                }

                function unselectElement() {
                    document.casinoSelector.selectedElement.style.pointerEvents = '';
                    document.casinoSelector.selectedElement.classList.remove('selectedDiv')
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    document.textarea.remove();
                    document.textarea = null;
                    document.parentUp.remove();
                    document.parentUp = null;
                    document.parentDown.remove();
                    document.parentDown = null;
                    document.serverChoser.remove();
                    document.serverChoser = null;
                    document.acceptTag.remove();
                    document.acceptTag = null;
                    document.reselectBtn.remove();
                    document.reselectBtn = null;
                    if (document.casinoSelector.selectedElement.getAttribute('style') == '') {
                        document.casinoSelector.selectedElement.removeAttribute('style')
                    }
                }
                function appendButtons(element) {
                    // offset element
                    if (document.textarea == null) {
                        let viewportOffset = element.getBoundingClientRect()
                        let top = getOffsetTop(element) + viewportOffset.height + 20,
                            // left = getOffsetLeft(element);
                        // left = viewportOffset.right > 1000 ? (getOffsetLeft(element) - (viewportOffset.width - 150)) : getOffsetLeft(element);
                        left = document.documentElement.offsetWidth - (viewportOffset.left + viewportOffset.width) < 150 ? (getOffsetLeft(element) - (viewportOffset.width - 150) < 0 ? getOffsetLeft(element) : getOffsetLeft(element) - (viewportOffset.width - 150)) : getOffsetLeft(element);
                        debugger
                        let textarea = document.createElement('textarea')
                        textarea.placeholder = 'Enter a comment for the element'
                        textarea.style.setProperty('background', 'transparent', 'important')
                        textarea.style.setProperty('font-family', 'sans-serif', 'important')
                        textarea.style.setProperty('font-size', '16px', 'important')
                        textarea.style.setProperty('font-weight', '300', 'important')
                        textarea.setAttribute('rows', '5')
                        textarea.setAttribute('cols', '50')
                        textarea.style.position = 'absolute';
                        textarea.style.left = `${left}px`;
                        textarea.style.top = `${top}px`;
                        textarea.style.maxWidth = `400px`;
                        textarea.style.zIndex = '1000000000';
                        textarea.style.color = '#fff';
                        textarea.style.border = '1px solid white';
                        textarea.style.textAlign = 'left';
                        textarea.style.borderRadius = '3px';
                        textarea.classList.add('gibb')
                        textarea.style.outline = 'unset';
                        textarea.style.boxShadow = 'unset';

                        document.body.appendChild(textarea)
                        document.textarea = textarea;
                    }


                    // parentUp element
                    if (document.parentUp == null) {
                        let viewportOffset = element.getBoundingClientRect()
                        console.log('offset', viewportOffset)
                        console.log('offset', document.documentElement.offsetWidth - (viewportOffset.left + viewportOffset.width))
                        let top = getOffsetTop(element) - 40,
                            // left = getOffsetLeft(element);
                        // left = viewportOffset.right > 1000 ? (getOffsetLeft(element) - (viewportOffset.width - 150)) : getOffsetLeft(element);
                        left = document.documentElement.offsetWidth - (viewportOffset.left + viewportOffset.width) < 150 ? (getOffsetLeft(element) - (viewportOffset.width - 150) < 0 ? getOffsetLeft(element) : getOffsetLeft(element) - (viewportOffset.width - 150)) : getOffsetLeft(element);
                        let parentUp = document.createElement('button')
                        parentUp.onclick = upParent
                        parentUp.innerText = 'UP';
                        parentUp.style.padding = '7px 15px'
                        parentUp.style.fontSize = '20px';
                        parentUp.style.borderRadius = '3px';
                        parentUp.style.position = 'absolute';
                        parentUp.style.fontWeight = '400';
                        parentUp.style.textDecoration = 'none';
                        parentUp.style.left = `${left}px`;
                        parentUp.style.top = `${top - 20}px`;
                        parentUp.style.zIndex = '1000000000';
                        parentUp.style.color = 'white';
                        parentUp.style.setProperty('background', 'transparent', 'important')
                        parentUp.style.setProperty('font-family', 'sans-serif', 'important')
                        parentUp.style.border = '1px solid white';
                        parentUp.style.borderRadius = '3px';
                        parentUp.style.cursor = 'pointer';
                        parentUp.style.outline = 'unset';
                        parentUp.style.boxShadow = 'unset';
                        parentUp.classList.add('gibb')
                        document.body.appendChild(parentUp)
                        document.parentUp = parentUp;
                    }

                    // parentUp element
                    if (document.parentDown == null) {
                        let top = document.parentUp.offsetTop, left = document.parentUp.offsetLeft + document.parentUp.offsetWidth + 10;
                        let parentDown = document.createElement('button')
                        parentDown.onclick = downParent
                        parentDown.innerText = 'DOWN';
                        parentDown.style.padding = '7px 15px'
                        parentDown.style.fontSize = '20px';
                        parentDown.style.borderRadius = '3px';
                        parentDown.style.position = 'absolute';
                        parentDown.style.left = `${left}px`;
                        parentDown.style.fontWeight = '400';
                        parentDown.style.textDecoration = 'none';
                        parentDown.style.top = `${top}px`;
                        parentDown.style.zIndex = '1000000000';
                        parentDown.style.color = 'white';
                        parentDown.style.setProperty('background', 'transparent', 'important')
                        parentDown.style.setProperty('font-family', 'sans-serif', 'important')
                        parentDown.style.setProperty('border-color', 'white', 'important')
                        parentDown.style.border = '1px solid white';
                        parentDown.style.borderRadius = '3px';
                        parentDown.style.outline = 'unset';
                        parentDown.style.boxShadow = 'unset';
                        parentDown.classList.add('gibb')
                        // parentDown.style.cursor = 'pointer';
                        document.body.appendChild(parentDown)
                        document.parentDown = parentDown;
                    }

                    // serverChoser element
                    if (document.serverChoser == null) {
                        let top = document.parentUp.offsetTop, left = document.parentDown.offsetLeft + document.parentDown.offsetWidth + 10;
                        let serverChoser = document.createElement('button')
                        serverChoser.innerText = 'UK';
                        serverChoser.style.padding = '7px 15px'
                        serverChoser.style.fontSize = '20px';
                        serverChoser.style.borderRadius = '3px';
                        serverChoser.style.position = 'absolute';
                        serverChoser.style.left = `${left}px`;
                        serverChoser.style.top = `${top}px`;
                        serverChoser.style.textDecoration = 'none';
                        serverChoser.style.zIndex = '1000000000';
                        serverChoser.style.color = 'white';
                        serverChoser.style.fontWeight = '400';
                        serverChoser.style.setProperty('background', 'transparent', 'important')
                        serverChoser.style.setProperty('font-family', 'sans-serif', 'important')
                        serverChoser.style.border = '1px solid white';
                        serverChoser.style.borderRadius = '3px';
                        serverChoser.style.opacity = '0';
                        serverChoser.style.cursor = 'pointer';
                        serverChoser.style.outline = 'unset';
                        serverChoser.style.boxShadow = 'unset';
                        serverChoser.classList.add('gibb')
                        document.body.appendChild(serverChoser)
                        document.serverChoser = serverChoser;
                    }

                    // ACCEPT element
                    if (document.acceptTag == null) {
                        let top = document.parentUp.offsetTop, left = document.parentDown.offsetLeft + document.parentDown.offsetWidth + 10;
                        // let top = document.parentUp.offsetTop, left = document.serverChoser.offsetLeft + document.serverChoser.offsetWidth + 10;
                        let acceptTag = document.createElement('button')
                        acceptTag.onclick = confirmSend
                        acceptTag.innerText = 'Accept';
                        acceptTag.style.padding = '7px 15px'
                        acceptTag.style.fontSize = '20px';
                        acceptTag.style.borderRadius = '3px';
                        acceptTag.style.position = 'absolute';
                        acceptTag.style.left = `${left}px`;
                        acceptTag.style.fontWeight = '400';
                        acceptTag.style.top = `${top}px`;
                        acceptTag.style.textDecoration = 'none';
                        acceptTag.style.zIndex = '1000000000';
                        acceptTag.style.color = 'white';
                        acceptTag.style.setProperty('background', 'transparent', 'important')
                        acceptTag.style.setProperty('font-family', 'sans-serif', 'important')
                        acceptTag.style.border = '1px solid white';
                        acceptTag.style.borderRadius = '3px';
                        acceptTag.style.cursor = 'pointer';
                        acceptTag.style.outline = 'unset';
                        acceptTag.style.boxShadow = 'unset';
                        acceptTag.classList.add('gibb')
                        document.body.appendChild(acceptTag)
                        document.acceptTag = acceptTag;
                    }

                    // reselectBtn element
                    if (document.reselectBtn == null) {
                        let top = document.parentUp.offsetTop, left = document.acceptTag.offsetLeft + document.acceptTag.offsetWidth + 10;
                        // let top = document.parentUp.offsetTop, left = document.acceptTag.offsetLeft + document.acceptTag.offsetWidth + 10;
                        let reselectBtn = document.createElement('button')
                        reselectBtn.innerText = 'Reselect';
                        reselectBtn.onclick = reselect
                        reselectBtn.style.padding = '7px 15px'
                        reselectBtn.style.fontSize = '20px';
                        reselectBtn.style.fontWeight = '400';
                        reselectBtn.style.borderRadius = '3px';
                        reselectBtn.style.position = 'absolute';
                        reselectBtn.style.left = `${left}px`;
                        reselectBtn.style.textDecoration = 'none';
                        reselectBtn.style.top = `${top}px`;
                        reselectBtn.style.zIndex = '1000000000';
                        reselectBtn.style.color = 'white';
                        reselectBtn.style.setProperty('background', 'transparent', 'important')
                        reselectBtn.style.setProperty('font-family', 'sans-serif', 'important')
                        reselectBtn.style.border = '1px solid white';
                        reselectBtn.style.borderRadius = '3px';
                        reselectBtn.style.cursor = 'pointer';
                        reselectBtn.style.outline = 'unset';
                        reselectBtn.classList.add('gibb')
                        reselectBtn.style.boxShadow = 'unset';
                        document.body.appendChild(reselectBtn)
                        document.reselectBtn = reselectBtn;
                    }
                    document.body.querySelectorAll('div,li,tr,a,img').forEach(element => {
                        element.removeEventListener('click', clickListener)
                    })
                }
                function clickListener(e) {
                    if (!document.casinoSelector) {
                        return
                    }
                    e.preventDefault();
                    e.stopPropagation();
                    // e.preventDefault();
                    // 
                    // console.log('clicked')
                    // document.body.style.overflowX = 'hidden';
                    // document.body.style.height = '100%';
                    // document.body.style.margin = '0';
                    // document.documentElement.style.overflowX = 'hidden';
                    if (!document.inClickAction)
                        document.inClickAction = true;
                    let clickedElem = e.target;
                    if (e.target.tagName != 'DIV' && e.target.tagName != 'LI' && e.target.tagName != "TR") {
                        let skip = false;
                        if (e.target.parentElement.tagName == "TR") {
                            clickedElem = e.target.parentElement
                            let childs = [].slice.call(clickedElem.children);
                            childs.forEach((td, i) => {
                                td.style.zIndex = '1000000000'
                                // td.style.position = 'relative'
                            })
                            skip = true;
                            // console.log('clickedElem ', clickedElem)
                        }
                        if (event.target.parentElement.parentElement.tagName == 'TR' && !skip) {
                            event.target.parentElement.parentElement.classList.add('hovered')
                            clickedElem = e.target.parentElement.parentElement
                            let childs = [].slice.call(clickedElem.children);
                            childs.forEach((td, i) => {
                                td.style.zIndex = '1000000000'
                                // td.style.position = 'relative'
                            })
                            skip = true;
                        }
                        // if (event.target.parentElement.parentElement.parentElement.tagName == 'TR' && !skip) {
                        //     event.target.parentElement.parentElement.parentElement.classList.add('hovered')
                        //     clickedElem = e.target.parentElement.parentElement.parentElement
                        //     let childs = [].slice.call(clickedElem.children);
                        //     childs.forEach((td, i) => {
                        //         td.style.zIndex = '1000000000'
                        //         td.style.position = 'relative'
                        //     })
                        //     skip = true;
                        // }

                        if (e.target.tagName == 'IMG' || e.target.tagName == 'A') {

                        }

                        if (e.target.parentElement.tagName == 'DIV' || e.target.parentElement.tagName == 'LI' || e.target.parentElement.tagName == "TR") {
                            clickedElem = e.target.parentElement
                            let childs = [].slice.call(clickedElem.children);
                            childs.forEach((td, i) => {
                                td.style.zIndex = '1000000000'
                                // td.style.position = 'relative'
                            })
                            // console.log('clickedElem ', clickedElem)
                        } else if (e.target.parentElement.parentElement.tagName == 'DIV' || e.target.parentElement.parentElement.tagName == 'LI' || e.target.parentElement.parentElement.tagName == "TR") {
                            clickedElem = e.target.parentElement.parentElement
                            let childs = [].slice.call(clickedElem.children);
                            childs.forEach((td, i) => {
                                td.style.zIndex = '1000000000'
                                // td.style.position = 'relative'
                            })
                        } else {
                            return;
                        }
                    }
                    var getAbsPosition = function (el) {
                        var el2 = el;
                        var curtop = 0;
                        var curleft = 0;
                        if (document.getElementById || document.all) {
                            do {
                                curleft += el.offsetLeft - el.scrollLeft;
                                curtop += el.offsetTop - el.scrollTop;
                                el = el.offsetParent;
                                el2 = el2.parentNode;
                                while (el2 != el) {
                                    curleft -= el2.scrollLeft;
                                    curtop -= el2.scrollTop;
                                    el2 = el2.parentNode;
                                }
                            } while (el.offsetParent);

                        } else if (document.layers) {
                            curtop += el.y;
                            curleft += el.x;
                        }
                        return [curtop, curleft];
                    };

                    let elementAbsPosition = getAbsPosition(clickedElem)

                    infoPar.style.display = 'none';
                    overlay.style.pointerEvents = 'unset';
                    overlay.remove();
                    let elementRect = clickedElem.getBoundingClientRect();
                    let bodyRect = document.body.getBoundingClientRect();
                    // document.body.style.position = 'relative';
                    // 
                    if (!document.highlight1) {
                        document.highlight1 = document.createElement('div')
                        document.body.append(document.highlight1)
                    }
                    document.highlight1.style.position = 'absolute';
                    document.highlight1.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight1.style.width = '100%';
                    document.highlight1.style.height = (elementAbsPosition[0]) + 'px';
                    // document.highlight1.style.height = (clickedElem.offsetTop) + 'px';
                    document.highlight1.style.zIndex = '1000000000';
                    document.highlight1.style.top = '0';
                    document.highlight1.classList.add('hover-backlight');
                    document.highlight1.style.pointerEvents = 'unset';
                    document.highlight1.classList.add('gibb')

                    if (!document.highlight2) {
                        document.highlight2 = document.createElement('div')
                        document.body.append(document.highlight2)
                    }
                    document.highlight2.style.position = 'absolute';
                    document.highlight2.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight2.style.width = elementAbsPosition[1] + 'px';
                    // document.highlight2.style.width = clickedElem.offsetLeft + 'px';
                    document.highlight2.style.height = clickedElem.offsetHeight + 'px';
                    document.highlight2.style.zIndex = '1000000000';
                    // document.highlight2.style.top = (clickedElem.offsetTop) + 'px';
                    document.highlight2.style.top = elementAbsPosition[0] + 'px';
                    if (document.documentElement.getAttribute('dir') == 'rtl' || document.body.classList.contains('rtl') || document.documentElement.classList.contains('direction-rtl')) {
                        document.highlight2.style.left = '0';
                    } else {
                        document.highlight2.style.right = '0';
                    }
                    document.highlight2.classList.add('hover-backlight');
                    document.highlight2.style.pointerEvents = 'unset';
                    document.highlight2.classList.add('gibb')

                    if (!document.highlight3) {
                        document.highlight3 = document.createElement('div')
                        document.body.append(document.highlight3)
                    }
                    document.highlight3.style.position = 'absolute';
                    document.highlight3.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    // 
                    document.highlight3.style.width = (document.documentElement.offsetWidth - (elementAbsPosition[1] + clickedElem.offsetWidth)) + 'px';
                    // document.highlight3.style.width = (document.body.offsetWidth - (clickedElem.offsetLeft + clickedElem.offsetWidth)) + 'px';
                    document.highlight3.style.height = clickedElem.offsetHeight + 'px';
                    document.highlight3.style.zIndex = '1000000000';
                    // document.highlight3.style.top = (clickedElem.offsetTop) + 'px';
                    document.highlight3.style.top = elementAbsPosition[0] + 'px';
                    document.highlight3.style.right = '0';
                    document.highlight3.classList.add('hover-backlight');
                    document.highlight3.style.pointerEvents = 'unset';
                    document.highlight3.classList.add('gibb')

                    if (!document.highlight4) {
                        document.highlight4 = document.createElement('div')
                        document.body.append(document.highlight4)
                    }
                    document.highlight4.style.position = 'absolute';
                    document.highlight4.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight4.style.width = '100%';
                    // document.highlight4.style.height = '100vh';
                    document.highlight4.style.height = (document.body.scrollHeight - elementAbsPosition[0] - clickedElem.offsetHeight) + 'px';
                    // document.highlight4.style.height = 'calc(' + (clickedElem.offsetHeight + elementAbsPosition[0] - 5) + 'px' + ' + 100vh)';
                    // document.highlight4.style.height = 'calc(-' + (Math.max(Math.round(((clickedElem.offsetTop + clickedElem.offsetHeight) - bodyRect.top) * 10) / 10, 2.8).toFixed(1)) + 'px' + ' + 100vh)';
                    document.highlight4.style.zIndex = '1000000000';
                    document.highlight4.style.top = elementAbsPosition[0] + clickedElem.offsetHeight + 'px';
                    document.highlight4.style.right = '0';
                    document.highlight4.classList.add('hover-backlight');
                    document.highlight4.style.pointerEvents = 'unset';
                    document.highlight4.classList.add('gibb')

                    document.querySelectorAll('div,li,tr,a,img').forEach(el => {
                        el.removeEventListener('mouseover', mouseoverHandler)
                        el.removeEventListener('mouseout', mouseoutHandler)
                    })
                    e.preventDefault();
                    document.casinoSelector.selectedElement = clickedElem;
                    document.casinoSelector.selectedElement.absPosition = elementAbsPosition;
                    document.casinoSelector.selectedElement.style.pointerEvents = 'none';
                    // console.log(clickedElem.target)
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    clickedElem.classList.add('selectedDiv')
                    appendButtons(clickedElem)
                    document.parentDown.disabled = true
                    document.inClickAction = true;
                }

                var css = `.overlayChecker{background-color:rgba(0,0,0,0.65);position:fixed;height:100vh;display:flex;width:100vw;z-index:1000000000;top:0;pointer-events:none}
            .selectedDiv{box-shadow:1px 5px 15px 0 rgba(0,0,0,0.29);z-index:1000000001 !important;position:relative}
            button:disabled{opacity:0.5;cursor:no-drop}
            ::placeholder{color:white !important;opacity:1}
            *:not(p){transform: unset !important;}
            button.gibb:disabled{
                border-color:white !important
            }
            .hover-backlight{pointer-events:none}
            .hover-highlight{border-radius:2px;pointer-events:none;position:absolute;z-index:1000000001;animation:fade-in 125ms forwards cubic-bezier(0.07, 0.95, 0, 1);outline:2px dashed lightgray}
            .hovered{box-shadow:1px 5px 15px 0 rgba(0,0,0,0.29);z-index:1000000001 !important;outline:3px dotted white;background-color:rgba(255,255,255,0.8);position:relative}
            `;
                let head = document.head || document.getElementsByTagName('head')[0],
                    style = document.createElement('style');
                head.appendChild(style);
                document.style = style;


                // let hoverCss = `div:hover{box-shadow:1px 5px 15px 0 rgba(0,0,0,0.29);z-index:10000}`,
                //     hoverStyle = document.createElement('style');
                // head.appendChild(hoverStyle)
                // hoverStyle.appendChild(document.createTextNode(hoverCss))

                // append overlay
                let overlay = document.createElement('div')
                overlay.classList.add('overlayChecker')
                overlay.classList.add('gibb')
                document.body.append(overlay)
                document.overlay = overlay;
                // append overlay END


                let hoverHighlight = document.createElement('div')
                hoverHighlight.classList.add('hover-highlight')
                hoverHighlight.classList.add('gibb')
                document.body.append(hoverHighlight)
                document.hoverHighlight = hoverHighlight;
                // append overlay END



                style.appendChild(document.createTextNode(css));


                document.body.querySelectorAll('div,li,tr,a,img').forEach(element => {
                    element.addEventListener('click', function (e) {
                        event.preventDefault();
                        clickListener(e)
                    })
                })

                function timedAction(callback) {
                    clearTimeout(document.timer);
                    document.timer = setTimeout(callback, 200)
                }

                function confirmSend() {
                    let xml = new XMLHttpRequest();
                    xml.open("POST", "https://app.gibb.ai/api/submit");
                    // xml.open("POST", "http://localhost:8080/api/submit");
                    // xml.open("POST", "https://dev.gibb.ai/api/submit");
                    xml.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
                    xml.setRequestHeader("Authorization", "Bearer " + item.inspectorToken);
                    // let elem = document.querySelector('.selectedDiv').cloneNode(true)
                    let elem = document.casinoSelector.selectedElement.cloneNode(true)
                    // xml.onreadystatechange = function () {
                    //     if (xml.readyState == 4) {
                    //         quitSelector();
                    //         // return alert('tracking was submitted');
                    //     }
                    // }
                    if (!elem) {
                        return;
                    }
                    // 
                    elem.classList.remove('selectedDiv');
                    elem.classList.remove('hovered');

                    elem.style.pointerEvents = '';
                    elem.style.zIndex = '';
                    elem.style.pointerEvents = '';
                    let childs = [].slice.call(elem.getElementsByTagName('*'));
                    childs.forEach((td, i) => {
                        if (td.tagName == "TD") {
                            td.style.zIndex = '';
                            td.style.position = '';
                        }
                        td.classList.remove('hovered')
                        td.style.zIndex = '';
                        if (td.getAttribute('style') == '') {
                            td.removeAttribute('style')
                        }
                        td.removeAttribute('class')
                        while (td.attributes.length > 0)
                            td.removeAttribute(td.attributes[0].name);
                        // if (td.getAttribute('class') == '') {
                        //     td.removeAttribute('class')
                        // }
                        // td.removeAttribute('data-lazy-srcset')
                        // while (td.attributes.length > 0)
                        //     td.removeAttribute(td.attributes[0].name);
                    })
                    if (elem.getAttribute('style') == '') {
                        elem.removeAttribute('style')
                    }
                    // if (elem.getAttribute('class') == '') {
                    //     elem.removeAttribute('class')
                    // }
                    while (elem.attributes.length > 0)
                        elem.removeAttribute(elem.attributes[0].name);
                    // elem.removeAttribute('data-lazy-srcset')
                    // while (elem.attributes.length > 0)
                    //     elem.removeAttribute(elem.attributes[0].name);
                    xml.send(JSON.stringify({ element: elem.outerHTML, location: location.href, comment: document.textarea.value, position: elem.absPosition, pageTitle: document.title || '' }));
                    elem.classList.add('selectedDiv');
                    elem.style.pointerEvents = 'none';
                    quitSelector(true);
                }

                // function upParentapp.gibb.ai
                function upParent() {
                    let nextElement = document.casinoSelector.selectedElement.parentElement;
                    if (nextElement.tagName != 'DIV' &&
                        nextElement.tagName != 'LI' &&
                        nextElement.tagName != 'TR' &&
                        nextElement.tagName != 'A' &&
                        nextElement.tagName != 'IMG'
                    ) {
                        if (nextElement.parentElement.tagName == 'DIV' &&
                            nextElement.parentElement.tagName == 'LI' &&
                            nextElement.parentElement.tagName == 'TR' &&
                            nextElement.parentElement.tagName == 'A' &&
                            nextElement.parentElement.tagName == 'IMG') {
                            nextElement = nextElement.parentElement;
                        } else if (nextElement.parentElement.parentElement.tagName == 'DIV' &&
                            nextElement.parentElement.parentElement.tagName == 'LI' &&
                            nextElement.parentElement.parentElement.tagName == 'TR' &&
                            nextElement.parentElement.parentElement.tagName == 'A' &&
                            nextElement.parentElement.parentElement.tagName == 'IMG') {
                            nextElement = nextElement.parentElement.parentElement;
                        } else if (nextElement.parentElement.parentElement.parentElement.tagName == 'DIV' &&
                            nextElement.parentElement.parentElement.parentElement.tagName == 'LI' &&
                            nextElement.parentElement.parentElement.parentElement.tagName == 'TR' &&
                            nextElement.parentElement.parentElement.parentElement.tagName == 'A' &&
                            nextElement.parentElement.parentElement.parentElement.tagName == 'IMG') {
                            nextElement = nextElement.parentElement.parentElement.parentElement;
                        }
                    }
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('hovered'))
                    document.casinoSelector.selectHistory.push(document.casinoSelector.selectedElement)
                    // 
                    unselectElement();
                    document.casinoSelector.selectedElement = nextElement;
                    document.casinoSelector.selectedElement.classList.add('selectedDiv')
                    document.casinoSelector.selectedElement.latestPosition = document.casinoSelector.selectedElement.style.position;
                    // document.casinoSelector.selectedElement.style.position = 'relative'
                    appendButtons(document.casinoSelector.selectedElement)
                    document.parentDown.disabled = false;
                    highlightElement(document.casinoSelector.selectedElement)
                }

                function downParent() {
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('selectedDiv'))
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => el.classList.remove('hovered'))
                    if (document.casinoSelector.selectHistory.length > 0) {
                        unselectElement();
                        // 
                        document.casinoSelector.selectedElement.style.position = document.casinoSelector.selectedElement.latestPosition || '';
                        let elem = document.casinoSelector.selectHistory.pop()
                        document.casinoSelector.selectedElement.classList.remove('selectedDiv')
                        document.casinoSelector.selectedElement = elem
                        elem.classList.add('selectedDiv')
                        appendButtons(elem)
                        highlightElement(document.casinoSelector.selectedElement)
                    }
                    if (document.casinoSelector.selectHistory.length == 0) {
                        document.parentDown.disabled = true
                    }


                }

                function reselect() {
                    // document.body.style.overflow = '';
                    document.body.append(overlay)
                    overlay.style.pointerEvents = 'none';
                    // document.highlight1.remove();
                    // document.highlight2.remove();
                    // document.highlight3.remove();
                    // document.highlight4.remove();
                    infoPar.style.display = '';
                    infoPar.style.pointerEvents = 'none';
                    document.casinoSelector.selectedElement.style.pointerEvents = 'unset';
                    let childs = [].slice.call(document.casinoSelector.selectedElement.children);
                    childs.forEach((td, i) => {
                        td.classList.remove('hovered')
                        td.style.zIndex = 'unset';
                    })
                    unselectElement();
                    document.casinoSelector.selectHistory = []
                    document.casinoSelector.selectedElement = null;
                    document.body.querySelectorAll('div,li,tr,a,img').forEach(element => {
                        element.addEventListener('click', clickListener)
                        element.classList.remove('hovered')
                        element.classList.remove('selectedDiv')
                    })
                    document.querySelectorAll('div,li,tr,a,img').forEach(el => {
                        el.addEventListener('mouseover', mouseoverHandler)
                        el.addEventListener('mouseout', mouseoutHandler)
                    })
                    // head.appendChild(hoverStyle)
                }

                function highlightElement(clickedElem) {
                    var getAbsPosition = function (el) {
                        var el2 = el;
                        var curtop = 0;
                        var curleft = 0;
                        if (document.getElementById || document.all) {
                            do {
                                curleft += el.offsetLeft - el.scrollLeft;
                                curtop += el.offsetTop - el.scrollTop;
                                el = el.offsetParent;
                                el2 = el2.parentNode;
                                while (el2 != el) {
                                    curleft -= el2.scrollLeft;
                                    curtop -= el2.scrollTop;
                                    el2 = el2.parentNode;
                                }
                            } while (el.offsetParent);

                        } else if (document.layers) {
                            curtop += el.y;
                            curleft += el.x;
                        }
                        return [curtop, curleft];
                    };

                    let elementAbsPosition = getAbsPosition(clickedElem)
                    if (document.casinoSelector.selectedElement)
                        document.casinoSelector.selectedElement.absPosition = elementAbsPosition;

                    // infoPar.style.display = 'none';
                    overlay.style.pointerEvents = 'unset';
                    overlay.remove();
                    let elementRect = clickedElem.getBoundingClientRect();
                    let bodyRect = document.body.getBoundingClientRect();
                    // document.body.style.position = 'relative';
                    // 
                    if (!document.highlight1) {
                        document.highlight1 = document.createElement('div')
                        document.body.append(document.highlight1)
                    }
                    document.highlight1.style.position = 'absolute';
                    document.highlight1.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight1.style.width = '100%';
                    document.highlight1.style.height = (elementAbsPosition[0]) + 'px';
                    // document.highlight1.style.height = (clickedElem.offsetTop) + 'px';
                    document.highlight1.style.zIndex = '1000000000';
                    document.highlight1.style.top = '0';
                    document.highlight1.classList.add('hover-backlight');

                    if (!document.highlight2) {
                        document.highlight2 = document.createElement('div')
                        document.body.append(document.highlight2)
                    }
                    document.highlight2.style.position = 'absolute';
                    document.highlight2.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight2.style.width = elementAbsPosition[1] + 'px';
                    // document.highlight2.style.width = (elementAbsPosition[1] - clickedElem.offsetWidth) + 'px';
                    // document.highlight2.style.width = clickedElem.offsetLeft + 'px';
                    document.highlight2.style.height = clickedElem.offsetHeight + 'px';
                    document.highlight2.style.zIndex = '1000000000';
                    // document.highlight2.style.top = (clickedElem.offsetTop) + 'px';
                    document.highlight2.style.top = elementAbsPosition[0] + 'px';
                    document.highlight2.style.left = '0';
                    if (document.documentElement.getAttribute('dir') == 'rtl' || document.body.classList.contains('rtl') || document.documentElement.classList.contains('direction-rtl')) {
                        // document.highlight2.style.right = '0';
                        document.highlight2.style.left = 'unset';
                    } else {
                        document.highlight2.style.right = '0';
                    }
                    document.highlight2.classList.add('hover-backlight');

                    if (!document.highlight3) {
                        document.highlight3 = document.createElement('div')
                        document.body.append(document.highlight3)
                    }
                    document.highlight3.style.position = 'absolute';
                    document.highlight3.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    // document.highlight3.style.width = (document.body.offsetWidth - (elementAbsPosition[1] + clickedElem.offsetWidth)) + 'px';
                    document.highlight3.style.width = (document.documentElement.offsetWidth - (elementAbsPosition[1] + clickedElem.offsetWidth)) + 'px';
                    // document.highlight3.style.width = (document.body.offsetWidth - (clickedElem.offsetLeft + clickedElem.offsetWidth)) + 'px';
                    document.highlight3.style.height = clickedElem.offsetHeight + 'px';
                    document.highlight3.style.zIndex = '1000000000';
                    // document.highlight3.style.top = (clickedElem.offsetTop) + 'px';
                    document.highlight3.style.top = elementAbsPosition[0] + 'px';
                    if (document.documentElement.getAttribute('dir') == 'rtl' || document.body.classList.contains('rtl') || document.documentElement.classList.contains('direction-rtl')) {
                        document.highlight2.style.left = '0';
                    }
                    document.highlight3.style.right = '0';
                    document.highlight3.classList.add('hover-backlight');


                    if (!document.highlight4) {
                        document.highlight4 = document.createElement('div')
                        document.body.append(document.highlight4)
                    }
                    document.highlight4.style.position = 'absolute';
                    document.highlight4.style.backgroundColor = 'rgba(0,0,0,0.7)';
                    document.highlight4.style.width = '100%';
                    // document.highlight4.style.height = '100vh';
                    document.highlight4.style.height = (document.body.scrollHeight - elementAbsPosition[0] - clickedElem.offsetHeight) + 'px';
                    // document.highlight4.style.height = 'calc(' + (clickedElem.offsetHeight + elementAbsPosition[0] - 5) + 'px' + ' + 100vh)';
                    // document.highlight4.style.height = 'calc(-' + (Math.max(Math.round(((clickedElem.offsetTop + clickedElem.offsetHeight) - bodyRect.top) * 10) / 10, 2.8).toFixed(1)) + 'px' + ' + 100vh)';
                    document.highlight4.style.zIndex = '1000000000';
                    document.highlight4.style.top = elementAbsPosition[0] + clickedElem.offsetHeight + 'px';
                    document.highlight4.style.right = '0';
                    document.highlight4.classList.add('hover-backlight');
                }

                function getOffsetLeft(elem) {
                    var offsetLeft = 0;
                    do {
                        if (!isNaN(elem.offsetLeft)) {
                            offsetLeft += elem.offsetLeft;
                        }
                    } while (elem = elem.offsetParent);
                    return offsetLeft;
                }

                function getOffsetTop(elem) {
                    var offsetTop = 0;
                    do {
                        if (!isNaN(elem.offsetTop)) {
                            offsetTop += elem.offsetTop;
                        }
                    } while (elem = elem.offsetParent);
                    return offsetTop;
                }

                return document.body.innerHTML;
            })
        }
        let url;
        //We have permission to access the activeTab, so we can call chrome.tabs.executeScript:
        chrome.tabs.query({ currentWindow: true, active: true }, function (tabs) {
            if (!tabs[0].url.includes('chrome://')) {
                chrome.tabs.executeScript({
                    code: '(' + modifyDOM + ')();' //argument here is a string but function.toString() returns function's code
                }, (results) => {
                    chrome.storage.sync.get("inspectorToken", function (item) {
                        console.log(item)
                        if (item.inspectorToken == null) {
                            return;
                        } else {
                            window.close();
                        }
                    })

                    //Here we have just the innerHTML and not DOM structure
                    // console.log('Popup script:')
                    // console.log(results[0]);
                });
            } else {
                window.close()
            }
        });

    }
}, false);


